#include "pw/scene/scene.hpp"
#include "pw/scene/entity.hpp"

#include "pw/core/debug.hpp"

namespace pw {

scene::scene()
    : _registry{ std::make_shared<entt::registry>()}
{
}

size_t scene::count_all_enties() const
{
    return _registry->size();
}

size_t scene::count_alive_enties() const
{
    return _registry->alive();
}

void scene::update_transforms()
{

#if 0

    auto view = _registry->view<transform,relationship>();

    for (auto entity : view)
    {
        auto [t,r] = view.get<transform,relationship>(entity);

    }

        #endif



    auto view = _registry->view<relationship>();

    for (auto e : view) {

        const auto& r = view.get<relationship>(e);

        if (r.children.size() && r.parent == entt::null) {
            debug::d() << "root";
        }

//        debug::d() << __PRETTY_FUNCTION__ << " " << view.get<relationship>(e).children.size();

//        if
    }

//    auto vr = _registry->view<relationship>();

//    for (auto [rel] : vr) {

//    }

}




}
